# include <stdio.h>

int max(int a, int b) {
    return (a > b) ? a: b;
}

/* results array for memoization */
int results[101][1001];
void init( ) {
    int i, j;
    for(i = 0; i < 101; i++) {
        for(j = 0; j < 1001; j++) {
            results[i][j] = -1;
        }
    }
}

/* returns number of drops needed in worst case */
int drops(int boomas, int floors) {
    int best = floors + 1, f, worst;
    int ball_b, ball_n;

    /* base cases */
    if (floors == 1 || floors == 0)
        return floors;

    /* 1 ball means linear search */
    if (boomas == 1)
        return floors;

    /* check for pre-computed result */
    if(results[boomas][floors] != -1) {
        return results[boomas][floors];
    }

    /* try each floor */
    for(f = 1; f <= floors; f++) {
        /* case for the ball breaking */
        ball_b = drops(boomas - 1, f - 1);

        /* case for ball not breaking */
        ball_n = drops(boomas, floors-f);

        /* find worst case */
        worst = max(ball_b, ball_n);

        /* check if this floor is a better option */
        if (worst < best)
            best = worst;
    }

    /* memoize and return min + 1 for this drop */
    results[boomas][floors] = best + 1;
    return best + 1;
}


int main( ) {
    int trials, i;
    int boomas, floors;

    scanf("%d", &trials);
    for(i = 0; i < trials; i++) {
        scanf("%d %d", &boomas, &floors);
        init( );
        printf ("Minimum number of drops with %d boomas and %d floors is %d.\n", boomas, floors, drops(boomas, floors));
    }
    return 0;
}

